@echo off
rem (C) SSoft 2024 z-print@bk.ru
rem размещает все страницы из первого файла на подложки (шаблоны) из второго
rem и сохраняет в третий или в файл по умолчанию
rem то есть печать переменных данных на переменныхх шаблонах 
rem Warning'и можно игнорировать, обычно они связаны с поврежденными закладками
rem это стандартная бага cpdf, на работу никак не влияет
rem количество страниц в выходном строго соответствует кол-ву страниц в исходном файле переменных данных

IF NOT EXIST "%1" goto wrongfile
IF NOT EXIST "%2" goto wrongfile


set SRC=%1
set BACKS=%2

set OUT=%SRC:~0,-4%_with_backs.pdf
rem or set ouput name if it present in command line
IF NOT [%3]==[] set out=%3

rem Определим количество страниц в файле с переменными данными
rem тупо взял из сети, там какая-то заморочка
setlocal ENABLEDELAYEDEXPANSION
FOR /F "usebackq delims=" %%a IN (`cpdf -info %SRC% ^| find "Pages:"`) DO (set result=%%a)
rem отрежем слово pages: и используем остаток как число страниц (именно как число /a)
set /a varpages = %result:~7%

rem Определим количество страниц в файле с фонами
FOR /F "usebackq delims=" %%a IN (`cpdf -info %BACKS% ^| find "Pages:"`) DO (set result=%%a)
rem отрежем слово pages: и используем остаток как число страниц (именно как число /a)
set /a backpages = %result:~7%
echo Processing. Please wait
rem наделаем нужное количество подложек

for /L %%i in (1,%backpages%,%varpages%) do set LIST=!LIST!,1-%backpages%
set LIST=%LIST:~1%
cpdf "%BACKS%" -range %LIST% AND -combine-pages "%SRC%" AND -range 1-%varpages% -producer "SSoft mvardata" -o "%OUT%" > NUL

echo %OUT% Done!

exit /b 0

:wrongfile

echo (C) SSoft 2024 z-print@bk.ru
echo places variable data pages from variable_pages.pdf over backpages of templates.pdf again and again  
echo Usage: %0 variable_pages.pdf templates.pdf [outputfile.pdf]

IF NOT EXIST "%1" echo no variable data file %1
IF NOT EXIST "%2" echo no templates file %2
exit /b -1